image: ruby:2.7
stages:
  - deploy

cache:
  key: "$CI_BUILD_REF_NAME--$CI_BUILD_NAME"
  paths:
    - vendor

variables:
  APP_NAME: holyblocks
  REVIEW_APP_NAME: $APP_NAME-$CI_COMMIT_REF_SLUG

before_script:
  - apt-get update >/dev/null
  - apt-get install -y locales >/dev/null
  - echo "de_DE UTF-8" > /etc/locale.gen
  - locale-gen de_DE.UTF-8
  - export LANG=de_DE.UTF-8
  - export LANGUAGE=de_DE:de
  - export LC_ALL=de_DE.UTF-8
  - ruby -v
  - which ruby
  - gem install bundler

pages: #Name required by Gitlab Pages!
  stage: deploy
  script:
    - bundle install --jobs $(nproc) --path vendor/
    - bundle exec jekyll build -d public
  artifacts:
    expire_in: 1 month
    paths:
    - public

.dokku-setup:
  image: ilyasemenov/gitlab-ci-git-push
  dependencies: []
  cache: {}
  before_script:
  - mkdir -p ~/.ssh && echo "$SSH_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa && chmod 600 ~/.ssh/id_rsa
  - ssh-keyscan -H -p 22 "$DOKKU_HOST" >> ~/.ssh/known_hosts


deploy:
  stage: deploy
  extends: .dokku-setup
  environment:
    name: production
    url: https://$APP_NAME.$DOKKU_HOST/
  only:
  - master
  script:
  - git-push ssh://dokku@$DOKKU_HOST:22/$APP_NAME

review_app:
  stage: deploy
  extends: .dokku-setup
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$REVIEW_APP_NAME.$DOKKU_HOST/
    on_stop: stop_review_app
  only:
  - branches
  except:
  - master
  script:
  - echo "https://$REVIEW_APP_NAME.$DOKKU_HOST/"
  - ssh -t dokku@$DOKKU_HOST -- apps:clone --ignore-existing --skip-deploy "$APP_NAME" "$REVIEW_APP_NAME"
  - git-push ssh://dokku@$DOKKU_HOST:22/$REVIEW_APP_NAME
  - ssh -t dokku@$DOKKU_HOST -- letsencrypt "$REVIEW_APP_NAME"

stop_review_app:
  stage: deploy
  extends: .dokku-setup
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  when: manual
  script:
  - ssh -t dokku@$DOKKU_HOST -- --force apps:destroy "$REVIEW_APP_NAME"

